/*
{
  "IMPORTED" : [
    {
      "NAME" : "iChannel1",
      "PATH" : "8de3a3924cb95bd0e95a443fff0326c869f9d4979cd1d5b6e94e2a01f5be53e9.jpg"
    }
  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Shadertoy"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/wdsSRX by Plento.  Old shader thats been sitting in private. Might need to restart shader to load texture.",
  "PASSES" : [
    {
      "TARGET" : "BufferA",
      "PERSISTENT" : true,
      "FLOAT" : true
    },
    {

    }
  ],
  "INPUTS" : [

  ]
}
*/


const float pi = 3.1415926;
vec2 hash22(vec2 p) // Dave hoshkin hash
{
	vec3 p3 = fract(vec3(p.xyx) * vec3(.1031, .1030, .0973));
    p3 += dot(p3, p3.yzx+33.33);
    return fract((p3.xx+p3.yz)*p3.zy);
}

vec2 R;
vec4 T(vec2 p){
 	return IMG_NORM_PIXEL(BufferA,mod(p / R,1.0));   
    
}
vec4 T2(vec2 p){
 	return IMG_NORM_PIXEL(iChannel1,mod(p / R,1.0));
}


void main() {
	if (PASSINDEX == 0)	{


	    R = RENDERSIZE.xy;
	    
	    vec2 uv = gl_FragCoord.xy/R.xy;
		
	    vec4 col = vec4(0);
	
	    col = T(gl_FragCoord.xy);
	    
	    vec4 me = T(gl_FragCoord.xy);
	    
	    vec4 Up = T(gl_FragCoord.xy + vec2(.0, 1.));
	    vec4 Down = T(gl_FragCoord.xy + vec2(.0, -1.));
	    vec4 Left = T(gl_FragCoord.xy + vec2(-1., .0));
	    vec4 Right = T(gl_FragCoord.xy + vec2(1., .0));
	    
	    vec2 resDir = normalize(Up.yz + Down.yz + Left.yz + Right.yz);
	    
	    resDir += (hash22(gl_FragCoord.xy - sin(uv*25.))*.1);
	    
	    float angle = abs(atan(resDir.y, resDir.x)) - pi;
	    
	 //   gl_FragCoord.x += 0.25;
	  //  gl_FragCoord.y += 0.3;
	    
	    float s = smoothstep(0.0, 1.0, angle);
	    vec4 newCol = mix(T(gl_FragCoord.xy + (resDir - 1.0)), col, s);
	    
	    col = newCol;
	    
	    if(FRAMEINDEX <= 5)
	        col = T2(gl_FragCoord.xy);
	    
	    gl_FragColor = col;
	}
	else if (PASSINDEX == 1)	{


	    vec2 uv = gl_FragCoord.xy/RENDERSIZE.xy;
	    vec4 col = IMG_NORM_PIXEL(BufferA,mod(uv,1.0));
	
	    gl_FragColor = col;
	}
}
